<template>
  <section class="section" id="instances">
    <h1 class="title is-5">Instances</h1>
    <div v-if="instances && instances.length > 0" class="columns is-multiline">
      <div
        v-for="instance in instances"
        :key="instance.id"
        class="column is-full-mobile is-full-tablet is-full-desktop is-half-fullhd"
      >
        <div class="card">
          <div class="card-content">
            <div class="media">
              <figure class="media-left">
                <ServiceImage :service="serviceForInstanceUUID(instance.service_uuid)" />
              </figure>
              <div class="media-content">
                <div class="content">
                  <p>
                    <router-link
                      :to="{name: 'service-overview', params: {id: instance.service_uuid}}"
                    >
                      <strong
                        class="is-size-5"
                      >{{ serviceForInstanceUUID(instance.service_uuid).name }}</strong>
                    </router-link>&nbsp;
                    <span
                      class="has-text-grey is-uppercase is-size-7"
                    >Provisioned: &nbsp; {{ format_date(instance.subscription_start_time) }}</span>
                    <br />
                    <span class="has-text-grey-lighter is-size-7">{{instance.service_uuid}}</span>&nbsp;
                    <br />Access your service instance using the URL below. For more information about connecting please see our README.
                  </p>
                  <div class="field is-horizontal">
                    <div class="field-label is-small is-uppercase">Connection URL:</div>
                    <div class="field-body">
                      <ADisabledInput :placeholder="instance.dashboard_url" />
                    </div>
                  </div>
                </div>
              </div>
              <div class="media-right">
                <button v-on:click="activateDeprovisionModal(instance)" class="button is-danger">
                  <span class="icon is-small">
                    <svg
                      class="is-white"
                      role="img"
                      xmlns="http://www.w3.org/2000/svg"
                      width="24"
                      height="24"
                      viewBox="0 0 24 24"
                      aria-labelledby="closeIconTitle closeIconDesc"
                      stroke="#fff"
                      stroke-width="2"
                      stroke-linecap="square"
                      stroke-linejoin="miter"
                      fill="none"
                      color="#fff"
                    >
                      <title id="closeIconTitle">Close</title>
                      <desc id="closeIconDesc">Icon of a cross (x)</desc>
                      <path
                        d="M6.34314575 6.34314575L17.6568542 17.6568542M6.34314575 17.6568542L17.6568542 6.34314575"
                      />
                    </svg>
                  </span>
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div v-else class="columns">
      <div class="column is-one-third">
        <div class="card">
          <router-link :to="{name: 'service-catalog'}">
            <div class="card-content">Add an instance</div>
          </router-link>
        </div>
      </div>
    </div>

    <AnInstanceDeprovisionModal
      @closeModal="deactivateDeprovisionModal"
      :active="activateDeprovisioning"
      :instance="instanceToDeprovision"
    />
  </section>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import {
  ServiceInstance,
  emptyInstance
} from "@/services/arbalo_extensions/instances";
import moment from "moment";
import { CatalogItem } from "@/services/osb/catalog";
import ServiceImage from "@/components/ServiceImage.vue";
import ADisabledInput from "./ADisabledInput.vue";
import AnInstanceDeprovisionModal from "./AnInstanceDeprovisionModal.vue";

@Component({
  components: { ADisabledInput, ServiceImage, AnInstanceDeprovisionModal }
})
export default class ProjectInstances extends Vue {
  activateDeprovisioning = false;
  instanceToDeprovision: ServiceInstance = emptyInstance();

  @Prop() instances!: ServiceInstance[];

  format_date(input: string) {
    return moment(input).format("YYYY-MM-DD");
  }

  serviceForInstanceUUID(instanceUUID: string): CatalogItem {
    return this.$store.getters["catalog/getOfferingByID"](instanceUUID);
  }

  activateDeprovisionModal(instance: ServiceInstance) {
    this.activateDeprovisioning = true;
    this.instanceToDeprovision = instance;
  }

  deactivateDeprovisionModal() {
    this.instanceToDeprovision = emptyInstance();
    this.activateDeprovisioning = false;
  }
}
</script>

<style lang="scss" scoped>
</style>
